[保研/考研机试] 约瑟夫问题No.2 C++实现

题目要求:

输入、输出样例:

源代码:

cpp 复制代码
#include<iostream>
#include<queue>
#include<vector>
using namespace std;

//例题5.2 约瑟夫问题No.2
int main()
{
	int n, p, m;
	while (cin >> n >> p >> m) {
		//如果输入的是3个0,直接结束循环
		if (n == 0 && p == 0 && m == 0) {
			break;
		}
		//定义一个队列,用于存放n个小孩的编号
		queue<int> myQueue;
		//由于是从编号为p的小孩开始,直接按照 p,p+1,...n,1,2,...,p-1的顺序存入队列中
		for (int i = p; i <= n; i++) { // 存储p,p+1,...n的编号
			myQueue.push(i);
		}
		for (int i = 1; i < p; i++) { // 存储1,2,...,p-1的编号
			myQueue.push(i);
		}

		//定义一个vector,由于vector不会自动阿皮序,可以用于保存永久出队的元素的先后顺序,就是小孩从圈中出队的顺序
		vector<int> nums;
		//开始循环,只要队列不为空,说明小孩还没有全部出队,那就继续遍历
		while (!myQueue.empty()) {
			//由于报数是从1开始的,这里的i初始化为1,便于后续判断是否为4的整数倍
			//for循环的结束条件为nums中元素个数为小孩的总个数,说明此时小孩已经全部出队
			for (int i = 1; nums.size() < n; i++) {
				//当i为m的整数倍时,说明此时队头数字代表的小孩报数为m,直接出队,并且保存该数字到nums中
				//注意,要先保存到nums中,再出队
				if (i % m == 0) {
					nums.push_back(myQueue.front());
					myQueue.pop();
				}
				//当i不为m的整数倍时,说明此时队头数字代表的小孩报数不是m,直接放入队尾,出队,让下一个元素于队头
				else {
					myQueue.push(myQueue.front());
					myQueue.pop();
				}
			}
		}
		//由于输出用英文逗号隔开,且最后一个元素后面不需要逗号,那就先输出出最后的一个元素和逗号,再输出最后的元素
		for (int i = 0; i < nums.size()-1; i++) {
			cout << nums[i] << ",";
		}
		cout << nums[nums.size() - 1] << endl;
	}
	
	return 0;
}

运行结果:

相关推荐
dialect_6 小时前
KMP算法
开发语言·c++·算法
reikocao6 小时前
卡尔曼滤波的动态机制:P如何改变融合权重
算法
漂流瓶jz7 小时前
UVA-1612 猜名次 题解答案代码 算法竞赛入门经典第二版
数据结构·算法·题解·排序·aoapc·算法竞赛入门经典
吞下星星的少年·-·8 小时前
Div.2 CF 1130B题(构造,贪心)
算法·贪心·构造
ShineWinsu8 小时前
对于Qt:QRadioButton常见属性以及QButtonGroup的解析
数据库·c++·qt·microsoft·gui·qradiobutton·qbuttongroup
傲世仙尊8 小时前
多态-虚表才活到运行期符号表早已消失
c++
chenbingjie_c9 小时前
C++ 多态完全指南:从虚函数重写到虚函数表原理
开发语言·c++
是main不是漫9 小时前
【双指针——移动零】数组划分类题目的入门基石
c++·算法
·present·9 小时前
CSAPP(Bomb lab)
c语言·c++
王老师青少年编程9 小时前
2026年信奥赛c++普及组csp-j第二轮复赛真题
c++·真题·csp·信奥赛